#include "scrolblk.h"

ScrollBlock::ScrollBlock(rect coord, int type, char* fName, char* h,
	int shadow, int res, BORDERS b_type, BORDERS hdr_b_type, int pat,
	int hdr_pat, int elem_pat, int scroll_pat)
    : Bl(coord, fName, h, shadow, res, b_type, hdr_b_type, pat, hdr_pat,
	elem_pat)
    {
    scroll_type = type;
    rect r = w1->user_screen();
    if(type & HORIZ)
	{
	horiz_scroll_bar =
	    new ScrollBar(loc(r.origin.X,
		r.corner.Y - pScreenSet->cell_height),
		HORIZ, /*len*/r.width()
		- ((type & VERT) ? 2  * pScreenSet->cell_width : 0),
		/*tot*/10000, /*page_size*/1, /*cur*/0, scroll_pat);
	add(horiz_scroll_bar);
	}
    else
	horiz_scroll_bar = NULL;
    if(type & VERT)
	{
	vert_scroll_bar =
	    new ScrollBar(loc(r.corner.X - 2 * pScreenSet->cell_width,
		r.origin.Y), VERT,
		/*len*/r.height()
		- ((type & HORIZ) ? pScreenSet->cell_height : 0),
	    /*tot*/10000, /*page_size*/1, /*cur*/0, scroll_pat);
	add(vert_scroll_bar);
	}
    else
	vert_scroll_bar = NULL;
    moveTo(1);
    }
///////////////////////////////////////
void ScrollBlock::rearrange()
    {
    Bl::rearrange();
    rect r = w1->user_screen();
    if(scroll_type & HORIZ)
	horiz_scroll_bar->repose(rect(r.origin.X,
	    r.corner.Y - pScreenSet->cell_height,
	    r.corner.X - ((scroll_type & VERT)
		? 2  * pScreenSet->cell_width : 0), r.corner.Y));
    if(scroll_type & VERT)
	vert_scroll_bar->repose(rect(r.corner.X - 2 * pScreenSet->cell_width,
	    r.origin.Y, r.corner.X, r.corner.Y
	    - ((scroll_type & HORIZ) ? pScreenSet->cell_height : 0)));
    }
/////////////////////////////////////////
/*
void main()
    {
    if(!init_KNOW_HOW())
	return;
    setfillstyle(SOLID_FILL, pColorSet->colors.BAK_COLOR);
    bar(0, 0, getmaxx(), getmaxy());

    ScrollBlock b(rect(10, 10, 60, 20), HORIZ | VERT, "window.pcy",
	"Scrollable Block", 6,
	    MOVE | RESIZE, SHOW_BORDER, SHOW_BORDER,
	    0, 15, 16, 16);

    b.show_window();
//    b.exe();
    b.repose(rect(20, 5, 40, 12));
    b.show_window();

    close_KNOW_HOW();
    closegraph();
    }

*/